Re-work config and load paths to work with Debian's system MRI installation paths.
--- a/core/src/main/java/org/jruby/ext/rbconfig/RbConfigLibrary.java
+++ b/core/src/main/java/org/jruby/ext/rbconfig/RbConfigLibrary.java
@@ -55,7 +55,7 @@ import org.jruby.util.SafePropertyAccess
 public class RbConfigLibrary implements Library {
     // Ruby's designation for some platforms, minus version numbers in some cases
     private static final String RUBY_DARWIN = "darwin";
-    private static final String RUBY_LINUX = "linux";
+    private static final String RUBY_LINUX = "linux-gnu";
     private static final String RUBY_WIN32 = "mswin32";
     private static final String RUBY_SOLARIS = "solaris";
     private static final String RUBY_FREEBSD = "freebsd";
@@ -108,8 +108,8 @@ public class RbConfigLibrary implements
         return architecture;
     }
 
-    public static String getRuntimeVerStr(Ruby runtime) {
-        return Constants.RUBY_MAJOR_VERSION;
+    public static String getRuntimeVerStr() {
+        return Constants.RUBY_MAJOR_VERSION + ".0";
     }
 
     public static String getNormalizedHome(Ruby runtime) {
@@ -120,92 +120,64 @@ public class RbConfigLibrary implements
         return normalizedHome;
     }
 
-    public static String getLibDir(Ruby runtime) {
-        String libdir = SafePropertyAccessor.getProperty("jruby.lib");
-        if (libdir == null) {
-            String home = getNormalizedHome(runtime);
-            if (home.startsWith("uri:")) {
-                libdir = home + "/lib";
-            }
-            else {
-                libdir = newFile(home, "lib").getPath();
-            }
-        } else {
-            try {
-            // Our shell scripts pass in non-canonicalized paths, but even if we didn't
-            // anyone who did would become unhappy because Ruby apps expect no relative
-            // operators in the pathname (rubygems, for example).
-                libdir = newFile(libdir).getCanonicalPath();
-            }
-            catch (IOException e) {
-                libdir = newFile(libdir).getAbsolutePath();
-            }
-        }
-
-        return libdir;
+    public static String getTriple() {
+        return getArchitecture() + "-" + getOSName();
     }
 
-    public static String getVendorDirGeneral(Ruby runtime) {
-        // vendorDirGeneral example: /usr/share/jruby/lib/ - commonly the same as libdir
-        return newFile(SafePropertyAccessor.getProperty("vendor.dir.general", getLibDir(runtime))).getPath();
+    public static String getJrubyStandardLibraryDir() {
+        return "/usr/share/jruby/lib/ruby/stdlib";
     }
 
-    public static String getSiteDirGeneral(Ruby runtime) {
-        // siteDirGeneral example: /usr/local/share/jruby/lib/
-        return newFile(SafePropertyAccessor.getProperty("site.dir.general", getLibDir(runtime))).getPath();
+    public static String getLibDir() {
+        return "/usr/lib";
     }
 
-    public static Boolean isSiteVendorSame(Ruby runtime) {
-        return getVendorDirGeneral(runtime).equals(getSiteDirGeneral(runtime));
+    public static String getRubyArchPrefix() {
+        return getLibDir() + "/" + getTriple() + "/ruby";
     }
 
-    public static String getRubygemsDir(Ruby runtime) {
-        // used when integrating JRuby with system RubyGems - example: /usr/share/rubygems
-        return SafePropertyAccessor.getProperty("vendor.dir.rubygems", null);
+    public static String getArchDir() {
+        return getRubyArchPrefix() + "/" + getRuntimeVerStr();
     }
 
-    public static String getRubySharedLibDir(Ruby runtime) {
-        return newFile(getVendorDirGeneral(runtime), "ruby/shared").getPath();
+    public static String getRubySiteArchPrefix() {
+        return "/usr/local/lib/" + getTriple() + "/ruby";
     }
 
-    public static String getRubyLibDir(Ruby runtime) {
-        return getRubyLibDirFor(runtime, "stdlib");
+    public static String getRubyLibPrefix() {
+        return getLibDir() + "/ruby";
     }
 
-    public static String getRubyLibDirFor(Ruby runtime, String runtimeVerStr) {
-        return newFile(getVendorDirGeneral(runtime), String.format("ruby/%s", runtimeVerStr)).getPath();
+    public static String getRubyLibDir() {
+        return getRubyLibPrefix() + "/" + getRuntimeVerStr();
     }
 
-    public static String getArchDir(Ruby runtime) {
-        return getRubyLibDir(runtime);
+    public static String getVendorDir() {
+        return getRubyLibPrefix() + "/vendor_ruby";
     }
 
-    public static String getVendorDir(Ruby runtime) {
-        return newFile(getRubyLibDir(runtime), "vendor_ruby").getPath();
+    public static String getVendorLibDir() {
+        return getVendorDir() + "/" + getRuntimeVerStr();
     }
 
-    public static String getVendorLibDir(Ruby runtime) {
-        return getVendorDir(runtime);
+    public static String getVendorArchDir() {
+        return getRubyArchPrefix() + "/vendor_ruby/" + getRuntimeVerStr();
     }
 
-    public static String getVendorArchDir(Ruby runtime) {
-        return getVendorDir(runtime);
+    public static String getSiteDir() {
+        return "/usr/local/lib/site_ruby";
     }
 
-    public static String getSiteDir(Ruby runtime) {
-        return newFile(getSiteDirGeneral(runtime), String.format("ruby/%s/site_ruby", getRuntimeVerStr(runtime))).getPath();
+    public static String getSiteArchDir() {
+        return "/usr/local/lib/" + getTriple() + "/site_ruby";
     }
 
-    public static String getSiteLibDir(Ruby runtime) {
-        return getSiteDir(runtime);
+    public static String getSiteLibDir() {
+        return getSiteDir() + "/" + getRuntimeVerStr();
     }
 
-    public static String getSiteArchDir(Ruby runtime) {
-        return getSiteDir(runtime);
-    }
-
-    public static String getSysConfDir(Ruby runtime) {
-        return newFile(getNormalizedHome(runtime), "etc").getPath();
+    public static String getSysConfDir() {
+        return "/etc";
     }
 
     /**
@@ -241,9 +213,7 @@ public class RbConfigLibrary implements
         setConfig(context, CONFIG, "MINOR", minor);
         setConfig(context, CONFIG, "TEENY", teeny);
         setConfig(context, CONFIG, "ruby_version", major + '.' + minor + ".0");
-        // Rubygems is too specific on host cpu so until we have real need lets default to universal
-        //setConfig(CONFIG, "arch", System.getProperty("os.arch") + "-java" + System.getProperty("java.specification.version"));
-        setConfig(context, CONFIG, "arch", "universal-java" + System.getProperty("java.specification.version"));
+        setConfig(context, CONFIG, "arch", getTriple());
 
         // Use property for binDir if available, otherwise fall back to common bin default
         String binDir = SafePropertyAccessor.getProperty("jruby.bindir");
@@ -269,7 +239,7 @@ public class RbConfigLibrary implements
         setConfig(context, CONFIG, "host_vendor", vendor);
         setConfig(context, CONFIG, "host_cpu", arch);
 
-        String host = String.format("%s-%s-%s", osName, vendor, arch);
+        String host = String.format("%s-%s-%s", arch, vendor, osName);
         setConfig(context, CONFIG, "host", host);
         setConfig(context, CONFIG, "host_alias", host);
 
@@ -296,31 +266,29 @@ public class RbConfigLibrary implements
         setConfig(context, CONFIG, "target", Constants.TARGET);
 
 
-        String shareDir = newFile(normalizedHome, "share").getPath();
+        String shareDir = "/usr/share";
         String includeDir = newFile(normalizedHome, "lib/ruby/include").getPath();
 
-        String vendorDirGeneral = getVendorDirGeneral(runtime);
-        String siteDirGeneral = getSiteDirGeneral(runtime);
-        String rubySharedLibDir = getRubySharedLibDir(runtime);
-        String rubyLibDir = getRubyLibDir(runtime);
-        String archDir = getArchDir(runtime);
-        String vendorDir = getVendorDir(runtime);
-        String vendorLibDir = getVendorLibDir(runtime);
-        String vendorArchDir = getVendorArchDir(runtime);
-        String siteDir = getSiteDir(runtime);
-        String siteLibDir = getSiteLibDir(runtime);
-        String siteArchDir = getSiteArchDir(runtime);
-        String sysConfDir = getSysConfDir(runtime);
-
-        setConfig(context, CONFIG, "libdir", vendorDirGeneral);
-        setConfig(context, CONFIG, "rubylibprefix", vendorDirGeneral + "/ruby");
-        setConfig(context, CONFIG, "rubylibdir",     rubyLibDir);
-        setConfig(context, CONFIG, "rubysharedlibdir", rubySharedLibDir);
-        if (!isSiteVendorSame(runtime)) {
-            setConfig(context, CONFIG, "vendordir",      vendorDir);
-            setConfig(context, CONFIG, "vendorlibdir",   vendorLibDir);
-            setConfig(context, CONFIG, "vendorarchdir",    vendorArchDir);
-        }
+        String rubyLibDir = getRubyLibDir();
+        String archDir = getArchDir();
+        String libDir = getLibDir();
+        String vendorDir = getVendorDir();
+        String vendorLibDir = getVendorLibDir();
+        String vendorArchDir = getVendorArchDir();
+        String siteDir = getSiteDir();
+        String siteLibDir = getSiteLibDir();
+        String siteArchDir = getSiteArchDir();
+        String sysConfDir = getSysConfDir();
+
+        setConfig(context, CONFIG, "libdir", libDir);
+        setConfig(context, CONFIG, "rubylibdir", rubyLibDir);
+        setConfig(context, CONFIG, "rubylibprefix", getRubyLibPrefix());
+        setConfig(context, CONFIG, "rubyarchprefix", getRubyArchPrefix());
+        setConfig(context, CONFIG, "rubyarchdir", archDir);
+        setConfig(context, CONFIG, "rubysitearchprefix", getRubySiteArchPrefix());
+        setConfig(context, CONFIG, "vendordir", vendorDir);
+        setConfig(context, CONFIG, "vendorlibdir", vendorLibDir);
+        setConfig(context, CONFIG, "vendorarchdir", vendorArchDir);
         setConfig(context, CONFIG, "sitedir",        siteDir);
         setConfig(context, CONFIG, "sitelibdir",     siteLibDir);
         setConfig(context, CONFIG, "sitearchdir",    siteArchDir);
@@ -331,9 +299,9 @@ public class RbConfigLibrary implements
         setConfig(context, CONFIG, "rubyhdrdir",   includeDir);
         setConfig(context, CONFIG, "configure_args", "");
         setConfig(context, CONFIG, "datadir", shareDir);
-        setConfig(context, CONFIG, "mandir", newFile(normalizedHome, "man").getPath());
+        setConfig(context, CONFIG, "mandir", shareDir + "/man");
         setConfig(context, CONFIG, "sysconfdir", sysConfDir);
-        setConfig(context, CONFIG, "localstatedir", newFile(normalizedHome, "var").getPath());
+        setConfig(context, CONFIG, "localstatedir", "/var");
         setConfig(context, CONFIG, "DLEXT", "jar");
         if (Platform.IS_WINDOWS) {
             setConfig(context, CONFIG, "RUBY_SO_NAME", ((arch.equals("x86_64")) ? "x64-" : "") + "msvcrt-" + jrubyScript());
@@ -341,11 +309,6 @@ public class RbConfigLibrary implements
             setConfig(context, CONFIG, "RUBY_SO_NAME", "ruby");
         }
 
-        final String rubygemsDir = getRubygemsDir(runtime);
-        if (rubygemsDir != null) {
-            setConfig(context, CONFIG, "rubygemsdir", newFile(rubygemsDir).getPath());
-        }
-
         if (Platform.IS_WINDOWS) {
             setConfig(context, CONFIG, "EXEEXT", ".exe");
         } else {
@@ -372,15 +335,12 @@ public class RbConfigLibrary implements
         // TODO CONFIG and MAKEFILE_CONFIG seems to be the same Hash in Ruby 2.5
         final RubyHash mkmfHash = new RubyHash(runtime, 64);
 
-        setConfig(context, mkmfHash, "libdir", vendorDirGeneral);
+        setConfig(context, mkmfHash, "libdir", libDir);
         setConfig(context, mkmfHash, "arch", "java");
         setConfig(context, mkmfHash, "rubylibdir",     rubyLibDir);
-        setConfig(context, mkmfHash, "rubysharedlibdir", rubySharedLibDir);
-        if (!isSiteVendorSame(runtime)) {
-            setConfig(context, mkmfHash, "vendordir",      vendorDir);
-            setConfig(context, mkmfHash, "vendorlibdir",   vendorLibDir);
-            setConfig(context, mkmfHash, "vendorarchdir",  vendorArchDir);
-        }
+        setConfig(context, mkmfHash, "vendordir", vendorDir);
+        setConfig(context, mkmfHash, "vendorlibdir", vendorLibDir);
+        setConfig(context, mkmfHash, "vendorarchdir", vendorArchDir);
         setConfig(context, mkmfHash, "sitedir",        siteDir);
         setConfig(context, mkmfHash, "sitelibdir",     siteLibDir);
         setConfig(context, mkmfHash, "sitearchdir",    siteArchDir);
@@ -388,13 +348,10 @@ public class RbConfigLibrary implements
         setConfig(context, mkmfHash, "archdir",    archDir);
         setConfig(context, mkmfHash, "topdir",    archDir);
         setConfig(context, mkmfHash, "configure_args", "");
-        setConfig(context, mkmfHash, "datadir", newFile(normalizedHome, "share").getPath());
-        setConfig(context, mkmfHash, "mandir", newFile(normalizedHome, "man").getPath());
+        setConfig(context, mkmfHash, "datadir", shareDir);
+        setConfig(context, mkmfHash, "mandir", shareDir + "/man");
         setConfig(context, mkmfHash, "sysconfdir", sysConfDir);
-        setConfig(context, mkmfHash, "localstatedir", newFile(normalizedHome, "var").getPath());
-        if (rubygemsDir != null) {
-            setConfig(context, mkmfHash, "rubygemsdir", newFile(rubygemsDir).getPath());
-        }
+        setConfig(context, mkmfHash, "localstatedir", "/var");
 
         setupMakefileConfig(context, mkmfHash);
 
--- a/core/src/main/java/org/jruby/runtime/load/LoadService.java
+++ b/core/src/main/java/org/jruby/runtime/load/LoadService.java
@@ -237,20 +237,14 @@ public class LoadService {
                 // uses it to know where to insert gem paths into the load path. Removing it
                 // causes all gem paths to be inserted at the beginning, overriding paths
                 // added via -I.
-                addPath(RbConfigLibrary.getSiteDir(runtime));
-
-                // if vendorDirGeneral is different than siteDirGeneral,
-                // add vendorDir, too
-                // adding {vendor,site}{Lib,Arch}Dir dirs is not necessary,
-                // since they should be the same as {vendor,site}Dir
-                if (!RbConfigLibrary.isSiteVendorSame(runtime)) {
-                    addPath(RbConfigLibrary.getVendorDir(runtime));
-                }
-                String rubygemsDir = RbConfigLibrary.getRubygemsDir(runtime);
-                if (rubygemsDir != null) {
-                    addPath(rubygemsDir);
-                }
-                addPath(RbConfigLibrary.getRubyLibDir(runtime));
+                addPath(RbConfigLibrary.getSiteLibDir());
+                addPath(RbConfigLibrary.getSiteArchDir());
+                addPath(RbConfigLibrary.getSiteDir());
+                addPath(RbConfigLibrary.getJrubyStandardLibraryDir());
+                addPath(RbConfigLibrary.getVendorArchDir());
+                addPath(RbConfigLibrary.getVendorDir());
+                addPath(RbConfigLibrary.getRubyLibDir());
+                addPath(RbConfigLibrary.getArchDir());
             }
 
         } catch(SecurityException ignore) {}
--- a/core/src/main/java/org/jruby/ext/etc/RubyEtc.java
+++ b/core/src/main/java/org/jruby/ext/etc/RubyEtc.java
@@ -529,7 +529,7 @@ public class RubyEtc {
     @JRubyMethod(module = true)
     public static synchronized IRubyObject sysconfdir(ThreadContext context, IRubyObject recv) {
         Ruby runtime = context.getRuntime();
-        ByteList tmp = ByteList.create(RbConfigLibrary.getSysConfDir(runtime)); // default for all platforms except Windows
+        ByteList tmp = ByteList.create(RbConfigLibrary.getSysConfDir()); // default for all platforms except Windows
         
         if (Platform.IS_WINDOWS) {
             String localAppData = System.getenv("CSIDL_LOCAL_APPDATA");
--- a/lib/ruby/stdlib/rubygems/defaults/jruby.rb
+++ b/lib/ruby/stdlib/rubygems/defaults/jruby.rb
@@ -29,17 +29,6 @@ module Gem
     end
   end
 
-  # Default home directory path to be used if an alternate value is not
-  # specified in the environment.
-  #
-  # JRuby: We don't want gems installed in lib/jruby/gems, but rather
-  # to preserve the old location: lib/ruby/gems.
-  def self.default_dir
-    dir = RbConfig::CONFIG["default_gem_home"]
-    dir ||= File.join(RbConfig::CONFIG['libdir'], 'ruby', 'gems', 'shared')
-    dir
-  end
-
   # Default locations for RubyGems' .rb and bin files
   def self.default_rubygems_dirs
     [
